#!/bin/sh
#
#  Debian Service Menu
#
#  Copyright (C) 2004 Vittorio Palmisano (redclay at email dot it)
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

ACTION=$1
PKGNAME=$2

function get_file () {
	ch=`dpkg-deb -c $PKGNAME | grep $1 | sed s/'^.* \.\/\(.*\)$'/'\1'/`
	if [ $ch ]; then
		dpkg-deb -x $PKGNAME /tmp/debian-servicemenu-tmpdir
		cat /tmp/debian-servicemenu-tmpdir/$ch | gunzip > /tmp/debian-servicemenu-tmpfile
		kdialog --textbox /tmp/debian-servicemenu-tmpfile 800 600
		rm /tmp/debian-servicemenu-tmpfile
		rm -rf /tmp/debian-servicemenu-tmpdir
		return 0
	else 
		return 1
	fi
}

case $ACTION in
  info)
	dpkg-deb -I $PKGNAME > /tmp/debian-servicemenu-info
	echo " " >> /tmp/debian-servicemenu-info
	echo "Status: " >> /tmp/debian-servicemenu-info
	name=`basename $PKGNAME | cut -d_ -f1`
	dpkg-query -W --showformat='${Status}' $name >> /tmp/debian-servicemenu-info
	echo -e '\n----\nPackage contents:\n \n' >> /tmp/debian-servicemenu-info
	dpkg-deb -c $2 >> /tmp/debian-servicemenu-info
	kdialog --textbox /tmp/debian-servicemenu-info 800 600
	rm /tmp/debian-servicemenu-info
	exit 0
	;;

  inst_files)
	name=`basename $PKGNAME | cut -d_ -f1`
	status=`dpkg-query -W --showformat='${Status}' $name`
	if [ "$status" == "install ok installed" ]; then
		items=`dpkg-deb -c $PKGNAME | sed s/'^.* \.\(\/.*\)$'/'\1 \1'/`
		item=`kdialog --menu "Installed files:" $items`
		if [ $? -eq 0 ]; then
			kfmclient openProfile filemanagement $item
		fi
	else
		kdialog --msgbox 'Package not installed.'
	fi
	exit 0
	;;
	
  changelog)
	get_file 'changelog.gz' || get_file 'ChangeLog' || kdialog --msgbox 'Changelog file not found.'
	exit 0
	;;
  
  debian_changelog)
	get_file 'changelog.Debian.gz' || kdialog --msgbox 'changelog.Debian.gz not found.'
	exit 0
	;;

  *)
	exit 1
	;;
esac
